/*
 * Simple window event explorer for SMS/QDOS
 *
 * ex qtest;'n'
 *
 * n = 0 (or missing)  infinite timeout, signal timer events
 * n = 1 no signal timer events
 * n = 2 5 second wm_ptrt timeout
 * n = 3 (combined effect of 1+2)
 *
 * Strictly not (c) jrh
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <qdos.h>
#include <qptr.h>
#include <qlib.h>
#include <stdarg.h>
#include <sys/time.h>
#include <signal.h>
#include <unistd.h>

long (*_stackchannels) (long) = NULL;
long (*_cmdchannels) (long) = NULL;
long (*_conread) () = NULL;
long (*_conwrite) () = NULL;
void (*_consetup) (chanid_t, struct WINDOWDEF *) = NULL;
char *_endmsg = NULL;
char _prog_name [] = "silly little window test 2";

static long AHIT (struct WM_wwork *wwk, struct WM_appw *apw, 
		  struct WM_wstat *wst, short, short, short,
		  short, unsigned short);

static long ADRAW (struct WM_wwork *wwk, struct WM_appw *apw);

static struct WM_action adraw = {JSR, wm_drwaw, ADRAW};
static struct WM_action ahit = {JSR, wm_hitaw, AHIT};

#define ninfw    1		/* number of information windows */
#define ninfo    0		/* number of information objects */
#define nappl    4		/* number of application sub-windows */
#define nlitm    0

typedef struct astat
{
    int chid;
    int param;
} AST;

static AST ast0 = {0}, ast1 = {0};

static struct WM_wstat ws =	/* window status area */
{
    NULL,			/* *wwork point back to work def */
    NULL,			/* *wdef this was wdef */
    0,				/* chid chan ID enclosing pointer */
    0, 0, 0,			/* swnr, xpos, ypos sub-window and ptr posn */
    0, 0,			/* kstk, kprs key stroke and press */
    0,				/* evnt event vector */
    0, 0, 0, 0,			/* xsiz, ysiz, xorg, yorg  */
    0, 0,			/* ptpsx, ptpsy pointer position (abs) */
    FORM_QL4, 0, 0,		/* wmode, 2 spare window mode and spare */
    NULL,			/* *ciact current item "action" */
    -1,				/* citem  current item */
    0, 0, 0,			/* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,			/* cihxs,ys, cihxo,yo   current item hit area */
    {0, 0, 0, 0, 0, 0, 0, 0}	/* litem[40] loose item status */
};

static struct WM_infw infw[ninfw + 1] =	/* information window */
{
    {24, 188,			/* xsize, ysize size */
     0, 2,			/* xorg, yorg and origin */
     0,				/* flag no clear + shadow */
     0, 7, 0,			/* borw, borc, papr border width/clr,paper */
     NULL},			/* *pobj pointer to object list */
    {-1}			/* end of array */
};

static struct WM_appw aw0 =	/* application sub-window */
{
    452,140,			/* xsize, ysize         size */
    24, 1, 			/* xorg, yorg           and origin */
    0x0100,			/* flag                 no clear + shadow */
    1, 7, 0,			/* borw, borc, papr border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &adraw,			/* *draw                draw routine */
    &ahit,			/* *hit                 hit routine */
    NULL,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb    part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    &ast0
};

static struct WM_appw aw1 =	/* application sub-window */
{
    452, 110,			/* xsize, ysize         size */
    24, 142,			/* xorg, yorg     and origin */
    0,				/* flag                 no clear + shadow */
    1, 7, 0,			/* borw, borc, papr     border width/clr,paper */
    NULL,			/* *pspr                pointer to sprite */
    &adraw,			/* *draw                draw routine */
    NULL,			/* *hit                 hit routine */
    NULL,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    &ast1
};

static struct WM_appl appl[nappl + 1] =
{
    &aw1, &aw0, NULL
};

static struct WM_wwork ww =	/* window working definition */
{
    &ws,			/* *wstat pointer to status area */
    NULL,	                /* *wscale this was pointer to WDEF */  
    0,				/* chid channel ID */
    NULL,			/* *pprec pointer to pointer record */
    0,				/* psave  pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    appl,			/* *splst pointer to sprite list */
    476, 254,			/* xsize, ysize size */
    2, 1,			/* xorg, yorg and origin */
    0,				/* flag no clear + shadow */
    1, 7, 0,			/* borw, borc, papr border width/clr, paper */
    NULL,			/* *sprite pointer to sprite */
    1, 7,			/* curw, curc current item width/clr */
    3, 7, NULL, NULL,		/* uback, uink, *ublob, *upatt  unavail */
    0, 7, NULL, NULL,		/* aback, aink, *ablob, *apatt  avail */
    4, 0, NULL, NULL,		/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    ninfw, ninfo, infw,		/* ninfo, ninob, *pinfo info winds */
    nlitm, NULL,		/* nlitm, *plitm loose items */
    2, appl		/* nappl  *pappl appl winds */
};

static short wwFlag = 0;
static int pStId, pChId;

#ifndef wm_rptrt
# define wm_rptrt _wm_rptrt
  int wm_rptrt(WM_wwork_t *, short, unsigned short);
#endif

static void init_timer(void);

void _SigNoImp(void)
{
    static const QD_TEXTI (p, "SIGNAL extension not loaded\n");
    ut_mtext(0, (const QLSTR_t *)&p);
    exit(-15);
}

OutError (char *ctl,...)
{
    va_list va;
    char t[80];
    static int start = 0;
    int now;
	
    va_start (va, ctl);
    now = mt_rclck();
    if(start == 0)
    {
	start = now;
    }

    sprintf (t, "%6d: ", now-start);
    vsprintf (t+8, ctl, va);
    va_end (va);

    io_sstrg (pStId, -1, t, (short) strlen (t));
}
void signalTimer(int sig)
{
    OutError("Beep\n");
    init_timer();
}

void init_timer(void)
{
    signal(SIGALRM, signalTimer);
    alarm(5);
}

void  _Signals_Init(void);

int main (int ac, char **av)
{

    int res;
    char *sp;
    short nc;
    short opt;
    void * wm_vectr;
    long qptr_vers = 0;

    sp = *(av + 1);		
    nc = *((short *) sp);
    sp += 2;

    if (nc)
    {
	sp += ((nc) << 2);
    }
    nc = *((short *) sp);
    sp += 2;
    if(nc) opt = *sp-'0';

    _Signals_Init();
    ww.chid = io_open ("con_512x256a0x0", 0);
    
    if((wm_vectr = iop_pinf(ww.chid, -1, &qptr_vers)) <= 0)
    {
        exit(-1);
    }

    ws.wwork = &ww;		/* set cross reference */

    ast1.chid = pStId = io_open ("scr", 0);
    ast0.chid = pChId = io_open ("scr", 0);

    wm_prpos (&ww, -1, -1);
    wm_wdraw (&ww);
    OutError("-- init --\n");

    if((opt & 1) == 0)
    {
	init_timer();
	OutError("Using signal timer ... ");
    }
    nc = -1;
    if(opt & 2) nc = 250;
    OutError("Using wman timer of %d\n", nc);
    while (1)
    {
	res = wm_rptrt (&ww, nc, 0);
	OutError("main::result = %d\n", res);
    }
    return (0);
}

static long ADRAW (struct WM_wwork *wwk, struct WM_appw *apw)
{
    if(((AST *) apw->pstat)->chid > 0)
    {
        wm_swdef (wwk, apw, ((AST *) apw->pstat)->chid);
    }
    return 0;
}

void myhit(short x)
{
    OutError("**HIT** %d\n", x);
}
static long AHIT (struct WM_wwork *wwk, struct WM_appw *apw, 
		  struct WM_wstat *wst,
		  short x, short y, short key, 
		  short evnt, unsigned short timo)
{
    unsigned char ch;
    extern char *_sys_vars;

    if(wwFlag)
    {
        if(wwFlag & 1)
        {
            aw0.flag |= 0x100;
        }
        else
        {
            aw0.flag &= ~0x100;
        }
        wwFlag = 0;
    }
#if 1
    {
	static cnt = 0;
	ch = (unsigned char) *(short *)(_sys_var + 0x8a);
	OutError("ev %04x wst->ev %04x (%02x %02x) ch %02x %d kflg %x %x %d\n",
		 (unsigned short) evnt,
		 (unsigned short) wst->evnt,
		 (unsigned char) wst->kstk, (unsigned char) wst->kprs,
		 (unsigned char) ch, cnt,
		 aw0.flag, key, timo);
	cnt++;
    }
#endif
    if(key  == 0x57)
    {
	if(aw0.flag & 0x100) wwFlag = 2; else wwFlag = 1;
    }
    if(key == 3) exit(0);
    return timo;
}

int (*_Cstart) () = main;

